Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/WriteExif.pl	(revision 34921)
@@ -1097,6 +67,6 @@
 #------------------------------------------------------------------------------
 # Get binary CFA Pattern from a text string
-# Inputs: CFA pattern string (ie. '[Blue,Green][Green,Red]')
-# Returns: Binary CFA data or prints warning and returns undef on error
+# Inputs: Print-converted CFA pattern (eg. '[Blue,Green][Green,Red]')
+# Returns: CFA pattern as a string of numbers
 sub GetCFAPattern($)
 {
@@ -1107,5 +77,5 @@
     @cols or warn("Colors not separated by ','\n"), return undef;
     my $ny = @cols;
-    my $rtnVal = Set16u(scalar(@rows)) . Set16u(scalar(@cols));
+    my @a = (scalar(@rows), scalar(@cols));
     my %cfaLookup = (red=>0, green=>1, blue=>2, cyan=>3, magenta=>4, yellow=>5, white=>6);
     my $row;
@@ -1116,9 +86,9 @@
             tr/ \]\[//d;    # remove remaining brackets and any spaces
             my $c = $cfaLookup{lc($_)};
-            defined $c or warn("Unknown color '$_'\n"), return undef;
-            $rtnVal .= Set8u($c);
+            defined $c or warn("Unknown color '${_}'\n"), return undef;
+            push @a, $c;
         }
     }
-    return $rtnVal;
+    return "@a";
 }
 
@@ -1129,8 +99,8 @@
 sub CheckExif($$$)
 {
-    my ($exifTool, $tagInfo, $valPtr) = @_;
-    my $format = $$tagInfo{Format} || $$tagInfo{Writable} || $tagInfo->{Table}{WRITABLE};
+    my ($et, $tagInfo, $valPtr) = @_;
+    my $format = $$tagInfo{Format} || $$tagInfo{Writable} || $$tagInfo{Table}{WRITABLE};
     if (not $format or $format eq '1') {
-        if ($tagInfo->{Groups}{0} eq 'MakerNotes') {
+        if ($$tagInfo{Groups}{0} eq 'MakerNotes') {
             return undef;   # OK to have no format for makernotes
         } else {
@@ -1148,9 +118,9 @@
 sub EncodeExifText($$)
 {
-    my ($exifTool, $val) = @_;
+    my ($et, $val) = @_;
     # does the string contain special characters?
     if ($val =~ /[\x80-\xff]/) {
-        my $order = $exifTool->GetNewValues('ExifUnicodeByteOrder');
-        return "UNICODE\0" . $exifTool->Encode($val,'UCS2',$order);
+        my $order = $et->GetNewValue('ExifUnicodeByteOrder');
+        return "UNICODE\0" . $et->Encode($val,'UTF16',$order);
     } else {
         return "ASCII\0\0\0$val";
@@ -1159,41 +129,11 @@
 
 #------------------------------------------------------------------------------
-# insert writable properties into main tag table
-# Inputs: 0) tag table ref, 1) reference to writable properties
-#         2) [optional] CHECK_PROC reference
-sub InsertWritableProperties($$;$)
-{
-    my ($tagTablePtr, $writeTablePtr, $checkProc) = @_;
-    my $tag;
-    $checkProc and $tagTablePtr->{CHECK_PROC} = $checkProc;
-    foreach $tag (keys %$writeTablePtr) {
-        my $writeInfo = $$writeTablePtr{$tag};
-        my @infoList = GetTagInfoList($tagTablePtr, $tag);
-        if (@infoList) {
-            my $tagInfo;
-            foreach $tagInfo (@infoList) {
-                if (ref $writeInfo) {
-                    my $key;
-                    foreach $key (%$writeInfo) {
-                        $$tagInfo{$key} = $$writeInfo{$key} unless defined $$tagInfo{$key};
-                    }
-                } else {
-                    $$tagInfo{Writable} = $writeInfo unless defined $$tagInfo{Writable};
-                }
-            }
-        } else {
-            Image::ExifTool::AddTagToTable($tagTablePtr, $tag, $writeInfo);
-        }
-    }
-}
-
-#------------------------------------------------------------------------------
 # rebuild maker notes to properly contain all value data
 # (some manufacturers put value data outside maker notes!!)
-# Inputs: 0) ExifTool object ref, 1) tag table ref, 2) dirInfo ref
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
 # Returns: new maker note data (and creates MAKER_NOTE_FIXUP), or undef on error
 sub RebuildMakerNotes($$$)
 {
-    my ($exifTool, $tagTablePtr, $dirInfo) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dirStart = $$dirInfo{DirStart};
     my $dirLen = $$dirInfo{DirLen};
@@ -1203,5 +143,5 @@
     my %subdirInfo = %$dirInfo;
 
-    delete $exifTool->{MAKER_NOTE_FIXUP};
+    delete $$et{MAKER_NOTE_FIXUP};
 
     # don't need to rebuild text, BinaryData or PreviewImage maker notes
@@ -1217,9 +157,13 @@
     }
     my $saveOrder = GetByteOrder();
-    my $loc = Image::ExifTool::MakerNotes::LocateIFD($exifTool,\%subdirInfo);
+    my $loc = Image::ExifTool::MakerNotes::LocateIFD($et,\%subdirInfo);
     if (defined $loc) {
         my $makerFixup = $subdirInfo{Fixup} = new Image::ExifTool::Fixup;
         # create new exiftool object to rewrite the directory without changing it
         my $newTool = new Image::ExifTool;
+        $newTool->Options(
+            IgnoreMinorErrors => $$et{OPTIONS}{IgnoreMinorErrors},
+            FixBase           => $$et{OPTIONS}{FixBase},
+        );
         $newTool->Init();   # must do this before calling WriteDirectory()!
         # don't copy over preview image
@@ -1227,24 +171,24 @@
         # copy all transient members over in case they are used for writing
         # (Make, Model, etc)
-        foreach (grep /[a-z]/, keys %$exifTool) {
-            $$newTool{$_} = $$exifTool{$_};
+        foreach (grep /[a-z]/, keys %$et) {
+            $$newTool{$_} = $$et{$_};
         }
         # fix base offsets if specified
-        $newTool->Options(FixBase => $exifTool->Options('FixBase'));
+        $newTool->Options(FixBase => $et->Options('FixBase'));
         # set GENERATE_PREVIEW_INFO flag so PREVIEW_INFO will be generated
-        $newTool->{GENERATE_PREVIEW_INFO} = 1;
+        $$newTool{GENERATE_PREVIEW_INFO} = 1;
         # drop any large tags
-        $newTool->{DROP_TAGS} = 1;
+        $$newTool{DropTags} = 1;
         # initialize other necessary data members
-        $newTool->{FILE_TYPE} = $exifTool->{FILE_TYPE};
-        $newTool->{TIFF_TYPE} = $exifTool->{TIFF_TYPE};
+        $$newTool{FILE_TYPE} = $$et{FILE_TYPE};
+        $$newTool{TIFF_TYPE} = $$et{TIFF_TYPE};
         # rewrite maker notes
         $rtnValue = $newTool->WriteDirectory(\%subdirInfo, $tagTablePtr);
         if (defined $rtnValue and length $rtnValue) {
             # add the dummy/empty preview image if necessary
-            if ($newTool->{PREVIEW_INFO}) {
+            if ($$newTool{PREVIEW_INFO}) {
                 $makerFixup->SetMarkerPointers(\$rtnValue, 'PreviewImage', length($rtnValue));
-                $rtnValue .= $newTool->{PREVIEW_INFO}{Data};
-                delete $newTool->{PREVIEW_INFO};
+                $rtnValue .= $$newTool{PREVIEW_INFO}{Data};
+                delete $$newTool{PREVIEW_INFO};
             }
             # add makernote header
@@ -1252,19 +196,26 @@
                 my $hdr = substr($$dataPt, $dirStart, $loc);
                 # special case: convert Pentax/Samsung DNG maker notes to JPEG style
-                # (in JPEG, Pentax makernotes are absolute and start with "AOC\0")
-                if ($hdr =~ s/^(PENTAX |SAMSUNG)\0/AOC\0/) {
-                    # save fixup so we will adjust to absolute offsets when writing
-                    $exifTool->{MAKER_NOTE_FIXUP} = $makerFixup;
+                # (in JPEG, Pentax makernotes are absolute and start with "AOC\0" for some
+                # models, but in DNG images they are stored in tag 0xc634 of IFD0 and
+                # start with either "PENTAX \0" or "SAMSUNG\0")
+                if ($$dirInfo{Parent} eq 'IFD0' and $hdr =~ /^(PENTAX |SAMSUNG)\0/) {
+                    # convert to JPEG-style AOC maker notes if used by this model
+                    # (Note: this expression also appears in Exif.pm)
+                    if ($$et{Model} =~ /\b(K(-[57mrx]|(10|20|100|110|200)D|2000)|GX(10|20))\b/) {
+                        $hdr =~ s/^(PENTAX |SAMSUNG)\0/AOC\0/;
+                        # save fixup because AOC maker notes have absolute offsets
+                        $$et{MAKER_NOTE_FIXUP} = $makerFixup;
+                    }
                 }
                 $rtnValue = $hdr . $rtnValue;
                 # adjust fixup for shift in start position
-                $makerFixup->{Start} += length $hdr;
+                $$makerFixup{Start} += length $hdr;
             }
             # shift offsets according to original position of maker notes,
             # and relative to the makernotes Base
-            $makerFixup->{Shift} += $dataPos + $dirStart +
-                                    $$dirInfo{Base} - $subdirInfo{Base};
+            $$makerFixup{Shift} += $dataPos + $dirStart +
+                                   $$dirInfo{Base} - $subdirInfo{Base};
             # repair incorrect offsets if offsets were fixed
-            $makerFixup->{Shift} += $subdirInfo{FixedBy} || 0;
+            $$makerFixup{Shift} += $subdirInfo{FixedBy} || 0;
             # fix up pointers to the specified offset
             $makerFixup->ApplyFixup(\$rtnValue);
@@ -1272,6 +223,6 @@
             unless ($subdirInfo{Relative}) {
                 # set shift so offsets are all relative to start of maker notes
-                $makerFixup->{Shift} -= $dataPos + $dirStart;
-                $exifTool->{MAKER_NOTE_FIXUP} = $makerFixup;    # save fixup for later
+                $$makerFixup{Shift} -= $dataPos + $dirStart;
+                $$et{MAKER_NOTE_FIXUP} = $makerFixup;    # save fixup for later
             }
         }
@@ -1284,11 +235,11 @@
 #------------------------------------------------------------------------------
 # Sort IFD directory entries
-# Inputs: 0) data reference, 1) directory start, 2) number of entries
-sub SortIFD($$$)
+# Inputs: 0) data reference, 1) directory start, 2) number of entries,
+#         3) flag to treat 0 as a valid tag ID (as opposed to an empty IFD entry)
+sub SortIFD($$$;$)
 {
-    my ($dataPt, $dirStart, $numEntries) = @_;
+    my ($dataPt, $dirStart, $numEntries, $allowZero) = @_;
     my ($index, %entries);
     # split the directory into separate entries
-    my $newDir = '';
     for ($index=0; $index<$numEntries; ++$index) {
         my $entry = $dirStart + 2 + 12 * $index;
@@ -1296,5 +247,5 @@
         my $entryData = substr($$dataPt, $entry, 12);
         # silly software can pad directories with zero entries -- put these at the end
-        $tagID = 0x10000 unless $tagID or $index == 0;
+        $tagID = 0x10000 unless $tagID or $index == 0 or $allowZero;
         # add new entry (allow for duplicate tag ID's, which shouldn't normally happen)
         if ($entries{$tagID}) {
@@ -1306,4 +257,6 @@
     # sort the directory entries
     my @sortedTags = sort { $a <=> $b } keys %entries;
+    # generate the sorted IFD
+    my $newDir = '';
     foreach (@sortedTags) {
         $newDir .= $entries{$_};
@@ -1382,9 +335,73 @@
 sub UpdateTiffEnd($$)
 {
-    my ($exifTool, $end) = @_;
-    if (defined $exifTool->{TIFF_END} and
-        $exifTool->{TIFF_END} < $end)
+    my ($et, $end) = @_;
+    if (defined $$et{TIFF_END} and
+        $$et{TIFF_END} < $end)
     {
-        $exifTool->{TIFF_END} = $end;
+        $$et{TIFF_END} = $end;
+    }
+}
+
+#------------------------------------------------------------------------------
+# Validate image data size
+# Inputs: 0) ExifTool ref, 1) validate info hash ref,
+#         2) flag to issue error (ie. we're writing)
+# - issues warning or error if problems found
+sub ValidateImageData($$$;$)
+{
+    local $_;
+    my ($et, $vInfo, $dirName, $errFlag) = @_;
+
+    # determine the expected size of the image data for an uncompressed image
+    # (0x102 BitsPerSample, 0x103 Compression and 0x115 SamplesPerPixel
+    #  all default to a value of 1 if they don't exist)
+    if ((not defined $$vInfo{0x103} or $$vInfo{0x103} eq '1') and
+        $$vInfo{0x100} and $$vInfo{0x101} and ($$vInfo{0x117} or $$vInfo{0x145}))
+    {
+        my $samplesPerPix = $$vInfo{0x115} || 1;
+        my @bitsPerSample = $$vInfo{0x102} ? split(' ',$$vInfo{0x102}) : (1) x $samplesPerPix;
+        my $byteCountInfo = $$vInfo{0x117} || $$vInfo{0x145};
+        my $byteCounts = $$byteCountInfo[1];
+        my $totalBytes = 0;
+        $totalBytes += $_ foreach split ' ', $byteCounts;
+        my $minor;
+        $minor = 1 if $$et{DOC_NUM} or $$et{FILE_TYPE} ne 'TIFF';
+        unless (@bitsPerSample == $samplesPerPix) {
+            unless ($$et{FILE_TYPE} eq 'EPS' and @bitsPerSample == 1) {
+                # (just a warning for this problem)
+                my $s = $samplesPerPix eq '1' ? '' : 's';
+                $et->Warn("$dirName BitsPerSample should have $samplesPerPix value$s", $minor);
+            }
+            push @bitsPerSample, $bitsPerSample[0] while @bitsPerSample < $samplesPerPix;
+            foreach (@bitsPerSample) {
+                $et->WarnOnce("$dirName BitsPerSample values are different", $minor) if $_ ne $bitsPerSample[0];
+                $et->WarnOnce("Invalid $dirName BitsPerSample value", $minor) if $_ < 1 or $_ > 32;
+            }
+        }
+        my $bitsPerPixel = 0;
+        $bitsPerPixel += $_ foreach @bitsPerSample;
+        my $expectedBytes = int(($$vInfo{0x100} * $$vInfo{0x101} * $bitsPerPixel + 7) / 8);
+        if ($expectedBytes != $totalBytes and
+            # (this problem seems normal for certain types of RAW files...)
+            $$et{TIFF_TYPE} !~ /^(K25|KDC|MEF|ORF|SRF)$/)
+        {
+            my ($adj, $minor);
+            if ($expectedBytes > $totalBytes) {
+                $adj = 'Under'; # undersized is a bigger problem because we may lose data
+                $minor = 0 unless $errFlag;
+            } else {
+                $adj = 'Over';
+                $minor = 1;
+            }
+            my $msg = "${adj}sized $dirName $$byteCountInfo[0]{Name} ($totalBytes bytes, but expected $expectedBytes)";
+            if (not defined $minor) {
+                # this is a serious error if we are writing the file and there
+                # is a chance that we may not copy all of the image data
+                # (but make it minor to allow the file to be written anyway)
+                $et->Error($msg, 1);
+            } else {
+                $et->Warn($msg, $minor);
+            }
+        }
     }
 }
@@ -1396,12 +413,12 @@
 sub ExifErr($$$)
 {
-    my ($exifTool, $errStr, $tagTablePtr) = @_;
+    my ($et, $errStr, $tagTablePtr) = @_;
     # MakerNote errors are minor by default
-    my $minor = ($tagTablePtr->{GROUPS}{0} eq 'MakerNotes');
-    if ($tagTablePtr->{VARS} and $tagTablePtr->{VARS}{MINOR_ERRORS}) {
-        $exifTool->Warn("$errStr. IFD dropped.") and return '' if $minor;
+    my $minor = ($$tagTablePtr{GROUPS}{0} eq 'MakerNotes' or $$et{FILE_TYPE} eq 'MOV');
+    if ($$tagTablePtr{VARS} and $$tagTablePtr{VARS}{MINOR_ERRORS}) {
+        $et->Warn("$errStr. IFD dropped.") and return '' if $minor;
         $minor = 1;
     }
-    return undef if $exifTool->Error($errStr, $minor);
+    return undef if $et->Error($errStr, $minor);
     return '';
 }
@@ -1414,10 +431,10 @@
 sub ProcessTiffIFD($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access
     my $raf = $$dirInfo{RAF};
     my $base = $$dirInfo{Base} || 0;
     my $dirName = $$dirInfo{DirName};
-    my $magic = $dirInfo->{Subdir}{Magic} || 0x002a;
+    my $magic = $$dirInfo{Subdir}{Magic} || 0x002a;
     my $buff;
 
@@ -1427,8 +444,8 @@
         my $msg = "Invalid $dirName header";
         if ($$dirInfo{IsWriting}) {
-            $exifTool->Error($msg);
+            $et->Error($msg);
             return undef;
         } else {
-            $exifTool->Warn($msg);
+            $et->Warn($msg);
             return 0;
         }
@@ -1449,5 +466,5 @@
     if ($$dirInfo{IsWriting}) {
         # rewrite the Camera Profile IFD
-        my $newDir = WriteExif($exifTool, \%dirInfo, $tagTablePtr);
+        my $newDir = WriteExif($et, \%dirInfo, $tagTablePtr);
         # don't add header if error writing directory ($newDir is undef)
         # or if directory is being deleted ($newDir is empty)
@@ -1456,10 +473,10 @@
         return GetByteOrder() . Set16u($magic) . Set32u(8) . $newDir;
     }
-    if ($exifTool->{HTML_DUMP}) {
+    if ($$et{HTML_DUMP}) {
         my $tip = sprintf("Byte order: %s endian\nIdentifier: 0x%.4x\n%s offset: 0x%.4x",
                           (GetByteOrder() eq 'II') ? 'Little' : 'Big', $magic, $dirName, $offset);
-        $exifTool->HDump($base, 8, "$dirName header", $tip, 0);
+        $et->HDump($base, 8, "$dirName header", $tip, 0);
     }
-    return ProcessExif($exifTool, \%dirInfo, $tagTablePtr);
+    return ProcessExif($et, \%dirInfo, $tagTablePtr);
 }
 
@@ -1478,6 +495,6 @@
 sub WriteExif($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;      # allow dummy access to autoload this package
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;      # allow dummy access to autoload this package
     my $origDirInfo = $dirInfo; # save original dirInfo
     my $dataPt = $$dirInfo{DataPt};
@@ -1496,8 +513,8 @@
     my $fixup = $$dirInfo{Fixup} || new Image::ExifTool::Fixup;
     my $imageDataFlag = $$dirInfo{ImageData} || '';
-    my $verbose = $exifTool->Options('Verbose');
-    my $out = $exifTool->Options('TextOut');
+    my $verbose = $et->Options('Verbose');
+    my $out = $et->Options('TextOut');
     my ($nextIfdPos, %offsetData, $inMakerNotes);
-    my (@offsetInfo, %xDelete);
+    my (@offsetInfo, %validateInfo, %xDelete, $strEnc);
     my $deleteAll = 0;
     my $newData = '';   # initialize buffer to receive new directory data
@@ -1506,12 +523,22 @@
     $name = $dirName unless $name and $dirName eq 'MakerNotes' and $name !~ /^MakerNote/;
 
+    # save byte order of existing EXIF
+    $$et{SaveExifByteOrder} = GetByteOrder() if $dirName eq 'IFD0' or $dirName eq 'ExifIFD';
+
+    # set encoding for strings
+    $strEnc = $et->Options('CharsetEXIF') if $$tagTablePtr{GROUPS}{0} eq 'EXIF';
+
     # allow multiple IFD's in IFD0-IFD1-IFD2... chain
     $$dirInfo{Multi} = 1 if $dirName =~ /^(IFD0|SubIFD)$/ and not defined $$dirInfo{Multi};
-    $inMakerNotes = 1 if $tagTablePtr->{GROUPS}{0} eq 'MakerNotes';
+    $inMakerNotes = 1 if $$tagTablePtr{GROUPS}{0} eq 'MakerNotes';
     my $ifd;
+
 #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 # loop through each IFD
 #
     for ($ifd=0; ; ++$ifd) {  # loop through multiple IFD's
+
+        # make sure that Compression and SubfileType are defined for this IFD (for Condition's)
+        $$et{Compression} = $$et{SubfileType} = '';
 
         # save pointer to start of this IFD within the newData
@@ -1522,5 +549,5 @@
         if ($dirStart < 0 or $dirStart > $dataLen-2) {
             $mustRead = 1;
-        } elsif ($dirLen > 2) {
+        } elsif ($dirLen >= 2) {
             my $len = 2 + 12 * Get16u($dataPt, $dirStart);
             $mustRead = 1 if $dirStart + $len > $dataLen;
@@ -1533,10 +560,10 @@
                 my ($buff, $buf2);
                 unless ($raf->Seek($offset + $base, 0) and $raf->Read($buff,2) == 2) {
-                    return ExifErr($exifTool, "Bad IFD or truncated file in $name", $tagTablePtr);
+                    return ExifErr($et, "Bad IFD or truncated file in $name", $tagTablePtr);
                 }
                 my $len = 12 * Get16u(\$buff,0);
                 # (also read next IFD pointer if available)
                 unless ($raf->Read($buf2, $len+4) >= $len) {
-                    return ExifErr($exifTool, "Error reading $name", $tagTablePtr);
+                    return ExifErr($et, "Error reading $name", $tagTablePtr);
                 }
                 $buff .= $buf2;
@@ -1552,10 +579,10 @@
                 # only account for nextIFD pointer if we are going to use it
                 $len += 4 if $dataLen==$len+6 and ($$dirInfo{Multi} or $buff =~ /\0{4}$/);
-                UpdateTiffEnd($exifTool, $offset+$base+2+$len);
-            } elsif ($dirLen) {
+                UpdateTiffEnd($et, $offset+$base+2+$len);
+            } elsif ($dirLen and $dirStart + 4 >= $dataLen) {
                 # error if we can't load IFD (unless we are creating
                 # from scratch, in which case dirLen will be zero)
-                my $str = $exifTool->Options('IgnoreMinorErrors') ? 'Deleted bad' : 'Bad';
-                $exifTool->Error("$str $name directory", 1);
+                my $str = $et->Options('IgnoreMinorErrors') ? 'Deleted bad' : 'Bad';
+                $et->Error("$str $name directory", 1);
             }
         }
@@ -1565,5 +592,8 @@
             $dirEnd = $dirStart + 2 + 12 * $numEntries;
             if ($dirEnd > $dataLen) {
-                return ExifErr($exifTool, "Truncated $name directory", $tagTablePtr);
+                my $n = int(($dataLen - $dirStart - 2) / 12);
+                my $rtn = ExifErr($et, "Truncated $name directory", $tagTablePtr);
+                return undef unless $n and defined $rtn;
+                $numEntries = $n;   # continue processing the entries we have
             }
             # sort entries if necessary (but not in maker notes IFDs)
@@ -1573,7 +603,7 @@
                     my $tagID = Get16u($dataPt, $dirStart + 2 + 12 * $index);
                     # check for proper sequence (but ignore null entries at end)
-                    if ($tagID < $lastID and $tagID) {
-                        SortIFD($dataPt, $dirStart, $numEntries);
-                        $exifTool->Warn("Entries in $name were out of sequence. Fixed.",1);
+                    if ($tagID < $lastID and ($tagID or $$tagTablePtr{0})) {
+                        SortIFD($dataPt, $dirStart, $numEntries, $$tagTablePtr{0});
+                        $et->Warn("Entries in $name were out of sequence. Fixed.",1);
                         last;
                     }
@@ -1587,86 +617,26 @@
 
         # loop through new values and accumulate all information for this IFD
-        my (%set, $tagInfo);
+        my (%set, %mayDelete, $tagInfo);
         my $wrongDir = $crossDelete{$dirName};
-        foreach $tagInfo ($exifTool->GetNewTagInfoList($tagTablePtr)) {
+        my @newTagInfo = $et->GetNewTagInfoList($tagTablePtr);
+        foreach $tagInfo (@newTagInfo) {
             my $tagID = $$tagInfo{TagID};
-            # evaluate conditional lists now if necessary
-            if (ref $tagTablePtr->{$tagID} eq 'ARRAY' or $$tagInfo{Condition}) {
-                my $curInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID);
-                if (defined $curInfo and not $curInfo) {
-                    # need value to evaluate the condition
-                    my ($val) = $exifTool->GetNewValues($tagInfo);
-                    # must convert to binary for evaluating in Condition
-                    if ($$tagInfo{Format} and defined $val) {
-                        $val = WriteValue($val, $$tagInfo{Format}, $$tagInfo{Count});
-                    }
-                    if (defined $val) {
-                        my $fmt = $$tagInfo{Writable} || $$tagInfo{Format} || 'undef';
-                        my $cnt = $$tagInfo{Count} || 1;
-                        # always use old format/count for Condition in maker notes
-                        if ($inMakerNotes) {
-                            for ($index=0; $index<$numEntries; ++$index) {
-                                my $entry = $dirStart + 2 + 12 * $index;
-                                my $id = Get16u($dataPt, $entry);
-                                if ($id eq $tagID) {
-                                    my $f = Get16u($dataPt, $entry + 2);
-                                    if ($formatName[$f]) {
-                                        $fmt = $formatName[$f];
-                                        $cnt = Get32u($dataPt, $entry + 4);
-                                    }
-                                    last;
-                                }
-                            }
-                        }
-                        $curInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID, \$val, $fmt, $cnt);
-                    }
-                }
-                # don't set this tag unless valid for the current condition
-                next unless defined $curInfo and $curInfo eq $tagInfo;
-            }
-            if ($$tagInfo{WriteCondition}) {
-                my $self = $exifTool;   # set $self to be used in eval
-                #### eval WriteCondition ($self)
-                unless (eval $$tagInfo{WriteCondition}) {
-                    $@ and warn $@;
-                    next;
-                }
-            }
-            my $nvHash = $exifTool->GetNewValueHash($tagInfo, $dirName);
-            unless ($nvHash) {
-                next unless $wrongDir;
-                # delete stuff from the wrong directory if setting somewhere else
-                $nvHash = $exifTool->GetNewValueHash($tagInfo, $wrongDir);
-                next unless Image::ExifTool::IsOverwriting($nvHash);
-                # don't cross delete if specifically deleting from the other directory
-                my $val = Image::ExifTool::GetNewValues($nvHash);
-                next if not defined $val and $nvHash->{WantGroup} and
-                        lc($nvHash->{WantGroup}) eq lc($wrongDir);
-                # remove this tag if found in this IFD
-                $xDelete{$tagID} = 1;
-            }
-            if ($set{$tagID}) {
-                # this tag is being set twice, which can happen if two Condition's
-                # were true for this tag.  Hopefully the only case where this can
-                # happen is the MakerNotes tag since it may store two very different
-                # types of information (MakerNotes and PreviewImage), but we want
-                # to store the MakerNotes if both are available
-                if ($tagID == 0x927c and $dirName =~ /^(ExifIFD|IFD0)$/) {
-                    next if $$tagInfo{Name} eq 'PreviewImage';
-                } else {
-                    $exifTool->Warn(sprintf("Multiple new values for $name tag 0x%.4x",$tagID));
-                }
-            }
-            $set{$tagID} = $tagInfo;
-        }
-        
+            # must evaluate Condition later when we have all DataMember's available
+            $set{$tagID} = (ref $$tagTablePtr{$tagID} eq 'ARRAY' or $$tagInfo{Condition}) ? '' : $tagInfo;
+        }
+
         # fix base offsets (some cameras incorrectly write maker notes in IFD0)
         if ($dirName eq 'MakerNotes' and $$dirInfo{Parent} =~ /^(ExifIFD|IFD0)$/ and
-            $$exifTool{TIFF_TYPE} !~ /^(ARW|SR2)$/ and not $$exifTool{LeicaTrailerPos} and
-            Image::ExifTool::MakerNotes::FixBase($exifTool, $dirInfo))
+            $$et{TIFF_TYPE} !~ /^(ARW|SR2)$/ and not $$et{LeicaTrailerPos} and
+            Image::ExifTool::MakerNotes::FixBase($et, $dirInfo))
         {
             # update local variables from fixed values
             $base = $$dirInfo{Base};
             $dataPos = $$dirInfo{DataPos};
+            # changed if ForceWrite tag was was set to "FixBase"
+            ++$$et{CHANGED} if $$et{FORCE_WRITE}{FixBase};
+            if ($$et{TIFF_TYPE} eq 'SRW' and $$et{Make} eq 'SAMSUNG' and $$et{Model} eq 'EK-GN120') {
+                $et->Error("EK-GN120 SRW files are too buggy to write");
+            }
         }
 
@@ -1676,9 +646,9 @@
         if ($mandatory) {
             # use X/Y resolution values from JFIF if available
-            if ($dirName eq 'IFD0' and defined $$exifTool{JFIFYResolution}) {
+            if ($dirName eq 'IFD0' and defined $$et{JFIFYResolution}) {
                 my %ifd0Vals = %$mandatory;
-                $ifd0Vals{0x011a} = $$exifTool{JFIFXResolution};
-                $ifd0Vals{0x011b} = $$exifTool{JFIFYResolution};
-                $ifd0Vals{0x0128} = $$exifTool{JFIFResolutionUnit} + 1;
+                $ifd0Vals{0x011a} = $$et{JFIFXResolution};
+                $ifd0Vals{0x011b} = $$et{JFIFYResolution};
+                $ifd0Vals{0x0128} = $$et{JFIFResolutionUnit} + 1;
                 $mandatory = \%ifd0Vals;
             }
@@ -1687,5 +657,5 @@
             unless ($numEntries) {
                 foreach (keys %$mandatory) {
-                    $set{$_} or $set{$_} = $$tagTablePtr{$_};
+                    defined $set{$_} or $set{$_} = $$tagTablePtr{$_};
                 }
             }
@@ -1701,4 +671,5 @@
             #  logic to add new tags relies on ordered entries)
             foreach (keys %set) {
+                next unless $set{$_};
                 my $perm = $set{$_}{Permanent};
                 push @newTags, $_ if defined $perm and not $perm;
@@ -1707,10 +678,7 @@
         } else {
             # get a hash of directories we will be writing in this one
-            $addDirs = $exifTool->GetAddDirHash($tagTablePtr, $dirName);
+            $addDirs = $et->GetAddDirHash($tagTablePtr, $dirName);
             # make a union of tags & dirs (can set whole dirs, like MakerNotes)
-            my %allTags = %set;
-            foreach (keys %$addDirs) {
-                $allTags{$_} = $$addDirs{$_};
-            }
+            my %allTags = ( %set, %$addDirs );
             # make sorted list of new tags to be added
             @newTags = sort { $a <=> $b } keys(%allTags);
@@ -1731,5 +699,5 @@
 
         # patch for Canon EOS 40D firmware 1.0.4 bug (incorrect directory counts)
-        if ($inMakerNotes and $$exifTool{Model} eq 'Canon EOS 40D') {
+        if ($inMakerNotes and $$et{Model} eq 'Canon EOS 40D') {
             my $fmt = Get16u($dataPt, $dirStart + 2 + 12 * ($numEntries - 1) + 2);
             if ($fmt < 1 or $fmt > 13) {
@@ -1757,11 +725,17 @@
                     undef $oldImageData;
                     if ($oldFormat < 1 or $oldFormat > 13) {
+                        my $msg = "Bad format ($oldFormat) for $name entry $index";
                         # patch to preserve invalid directory entries in SubIFD3 of
                         # various Kodak Z-series cameras (Z812, Z1085IS, Z1275)
-                        if ($dirName eq 'MakerNotes' and $$exifTool{Make}=~/KODAK/i and
-                            $$dirInfo{Name} and $$dirInfo{Name} eq 'SubIFD3')
+                        # and some Sony cameras such as the DSC-P10
+                        if ($dirName eq 'MakerNotes' and (($$et{Make}=~/KODAK/i and
+                            $$dirInfo{Name} and $$dirInfo{Name} eq 'SubIFD3') or
+                            ($numEntries == 12 and $$et{Make} eq 'SONY' and $index >= 8)))
                         {
                             $dirBuff .= substr($$dataPt, $entry, 12);
-                            goto WroteIt;
+                            ++$index;
+                            $newID = $oldID;    # we wrote this
+                            $et->Warn($msg, 1);
+                            next;
                         }
                         # don't write out null directory entry
